Index: win32ss/user/user32/windows/font.c
===================================================================
--- win32ss/user/user32/windows/font.c	(revision 68654)
+++ win32ss/user/user32/windows/font.c	(working copy)
@@ -1104,234 +155,7 @@
 INT WINAPI DrawTextExW( HDC hdc, LPWSTR str, INT i_count,
                         LPRECT rect, UINT flags, LPDRAWTEXTPARAMS dtp )
 {
-    SIZE size;
-    const WCHAR *strPtr;
-    WCHAR *retstr, *p_retstr;
-    size_t size_retstr;
-    WCHAR line[MAX_BUFFER];
-    int len, lh, count=i_count;
-    TEXTMETRICW tm;
-    int lmargin = 0, rmargin = 0;
-    int x = rect->left, y = rect->top;
-    int width = rect->right - rect->left;
-    int max_width = 0;
-    int last_line;
-    int tabwidth /* to keep gcc happy */ = 0;
-    int prefix_offset;
-    ellipsis_data ellip;
-    BOOL invert_y=FALSE;
-
-    TRACE("%s, %d, [%s] %08x\n", debugstr_wn (str, count), count,
-        wine_dbgstr_rect(rect), flags);
-
-    if (dtp) TRACE("Params: iTabLength=%d, iLeftMargin=%d, iRightMargin=%d\n",
-          dtp->iTabLength, dtp->iLeftMargin, dtp->iRightMargin);
-
-    if (!str) return 0;
-
-    strPtr = str;
-
-    if (flags & DT_SINGLELINE)
-        flags &= ~DT_WORDBREAK;
-
-    GetTextMetricsW(hdc, &tm);
-    if (flags & DT_EXTERNALLEADING)
-	lh = tm.tmHeight + tm.tmExternalLeading;
-    else
-	lh = tm.tmHeight;
-
-    if (str[0] && count == 0)
-        return lh;
-
-    if (dtp && dtp->cbSize != sizeof(DRAWTEXTPARAMS))
-        return 0;
-
-    if (GetGraphicsMode(hdc) == GM_COMPATIBLE)
-    {
-        SIZE window_ext, viewport_ext;
-        GetWindowExtEx(hdc, &window_ext);
-        GetViewportExtEx(hdc, &viewport_ext);
-        if ((window_ext.cy > 0) != (viewport_ext.cy > 0))
-            invert_y = TRUE;
-    }
-
-    if (count == -1)
-    {
-        count = strlenW(str);
-        if (count == 0)
-        {
-            if( flags & DT_CALCRECT)
-            {
-                rect->right = rect->left;
-                if( flags & DT_SINGLELINE)
-                    rect->bottom = rect->top + (invert_y ? -lh : lh);
-                else
-                    rect->bottom = rect->top;
-            }
-            return lh;
-        }
-    }
-
-    if (dtp)
-    {
-        lmargin = dtp->iLeftMargin;
-        rmargin = dtp->iRightMargin;
-        if (!(flags & (DT_CENTER | DT_RIGHT)))
-            x += lmargin;
-        dtp->uiLengthDrawn = 0;     /* This param RECEIVES number of chars processed */
-    }
-
-    if (flags & DT_EXPANDTABS)
-    {
-        int tabstop = ((flags & DT_TABSTOP) && dtp) ? dtp->iTabLength : 8;
-	tabwidth = tm.tmAveCharWidth * tabstop;
-    }
-
-    if (flags & DT_CALCRECT) flags |= DT_NOCLIP;
-
-    if (flags & DT_MODIFYSTRING)
-    {
-        size_retstr = (count + 4) * sizeof (WCHAR);
-        retstr = HeapAlloc(GetProcessHeap(), 0, size_retstr);
-        if (!retstr) return 0;
-        memcpy (retstr, str, size_retstr);
-    }
-    else
-    {
-        size_retstr = 0;
-        retstr = NULL;
-    }
-    p_retstr = retstr;
-
-    do
-    {
-	len = sizeof(line)/sizeof(line[0]);
-	if (invert_y)
-            last_line = !(flags & DT_NOCLIP) && y - ((flags & DT_EDITCONTROL) ? 2*lh-1 : lh) < rect->bottom;
-	else
-            last_line = !(flags & DT_NOCLIP) && y + ((flags & DT_EDITCONTROL) ? 2*lh-1 : lh) > rect->bottom;
-	strPtr = TEXT_NextLineW(hdc, strPtr, &count, line, &len, width, flags, &size, last_line, &p_retstr, tabwidth, &prefix_offset, &ellip);
-
-#ifdef __REACTOS__
-    if (flags & DT_CENTER)
-    {
-        if (((rect->right - rect->left) < size.cx) && (flags & DT_CALCRECT))
-        {
-            x = rect->left + size.cx;
-        }
-        else
-        {
-            x = (rect->left + rect->right - size.cx) / 2;
-        }
-    }
-#else
-	if (flags & DT_CENTER) x = (rect->left + rect->right -
-				    size.cx) / 2;
-#endif
-	else if (flags & DT_RIGHT) x = rect->right - size.cx;
-
-	if (flags & DT_SINGLELINE)
-	{
-            if (flags & DT_VCENTER)
-#ifdef __REACTOS__
-            {
-                if (((rect->bottom - rect->top) < (invert_y ? -size.cy : size.cy)) && (flags & DT_CALCRECT))
-                {
-                    y = rect->top + (invert_y ? -size.cy : size.cy);
-                }
-                else
-                {
-#endif
-                    y = rect->top + (rect->bottom - rect->top) / 2 + (invert_y ? (size.cy / 2) : (-size.cy / 2));
-#ifdef __REACTOS__
-                }
-            }
-#endif
-            else if (flags & DT_BOTTOM)
-                y = rect->bottom + (invert_y ? 0 : -size.cy);
-        }
-
-	if (!(flags & DT_CALCRECT))
-	{
-            const WCHAR *str = line;
-            int xseg = x;
-            while (len)
-            {
-                int len_seg;
-                SIZE size;
-                if ((flags & DT_EXPANDTABS))
-                {
-                    const WCHAR *p;
-                    p = str; while (p < str+len && *p != TAB) p++;
-                    len_seg = p - str;
-                    if (len_seg != len && !GetTextExtentPointW(hdc, str, len_seg, &size))
-                    {
-                        HeapFree (GetProcessHeap(), 0, retstr);
-                        return 0;
-                    }
-                }
-                else
-                    len_seg = len;
-
-                if (!ExtTextOutW( hdc, xseg, y,
-                                 ((flags & DT_NOCLIP) ? 0 : ETO_CLIPPED) |
-                                 ((flags & DT_RTLREADING) ? ETO_RTLREADING : 0),
-                                 rect, str, len_seg, NULL ))
-                {
-                    HeapFree (GetProcessHeap(), 0, retstr);
-                    return 0;
-                }
-                if (prefix_offset != -1 && prefix_offset < len_seg)
-                {
-                    TEXT_DrawUnderscore (hdc, xseg, y + tm.tmAscent + 1, str, prefix_offset, (flags & DT_NOCLIP) ? NULL : rect);
-                }
-                len -= len_seg;
-                str += len_seg;
-                if (len)
-                {
-                    assert ((flags & DT_EXPANDTABS) && *str == TAB);
-                    len--; str++;
-                    xseg += ((size.cx/tabwidth)+1)*tabwidth;
-                    if (prefix_offset != -1)
-                    {
-                        if (prefix_offset < len_seg)
-                        {
-                            /* We have just drawn an underscore; we ought to
-                             * figure out where the next one is.  I am going
-                             * to leave it for now until I have a better model
-                             * for the line, which will make reprefixing easier.
-                             * This is where ellip would be used.
-                             */
-                            prefix_offset = -1;
-                        }
-                        else
-                            prefix_offset -= len_seg;
-                    }
-                }
-            }
-	}
-	else if (size.cx > max_width)
-	    max_width = size.cx;
-
-        y += invert_y ? -lh : lh;
-        if (dtp)
-            dtp->uiLengthDrawn += len;
-    }
-    while (strPtr && !last_line);
-
-    if (flags & DT_CALCRECT)
-    {
-	rect->right = rect->left + max_width;
-	rect->bottom = y;
-        if (dtp)
-            rect->right += lmargin + rmargin;
-    }
-    if (retstr)
-    {
-        memcpy (str, retstr, size_retstr);
-        HeapFree (GetProcessHeap(), 0, retstr);
-    }
-    return y - rect->top;
+   return DrawTextExWorker( hdc, str, i_count, rect, flags, dtp );
 }
 
 /***********************************************************************
Index: win32ss/user/user32/windows/menu.c
===================================================================
--- win32ss/user/user32/windows/menu.c	(revision 68654)
+++ win32ss/user/user32/windows/menu.c	(working copy)
@@ -1143,9 +1143,9 @@
         // Or this,
         //Item->cxBmp = mis.itemWidth;
         //Item->cyBmp = mis.itemHeight;
-        TRACE("id=%04lx size=%dx%d\n",
+        TRACE("id=%04lx size=%dx%d cx %d cy %d\n",
                 lpitem->wID, lpitem->Rect.right-lpitem->Rect.left,
-                 lpitem->Rect.bottom-lpitem->Rect.top);
+                 lpitem->Rect.bottom-lpitem->Rect.top, MenuCharSize.cx, MenuCharSize.cy);
         return;
     }
 
@@ -3746,7 +3746,7 @@
     /* owner may not be visible when tracking a popup, so use the menu itself */
     capture_win = (wFlags & TPM_POPUPMENU) ? MenuInfo.Wnd : mt.OwnerWnd;
     NtUserxSetGUIThreadHandle(MSQ_STATE_MENUOWNER, capture_win); // 1
-    SetCapture(capture_win);                                          // 2
+    SetCapture(capture_win);                                     // 2
 
     while (!fEndMenu)
     {
@@ -4753,19 +4753,19 @@
 BOOL WINAPI HiliteMenuItem( HWND hWnd, HMENU hMenu, UINT wItemID,
                                 UINT wHilite )
 {
-    ROSMENUINFO MenuInfo;
-    TRACE("(%p, %p, %04x, %04x);\n", hWnd, hMenu, wItemID, wHilite);
+    //ROSMENUINFO MenuInfo;
+    ERR("(%p, %p, %04x, %04x);\n", hWnd, hMenu, wItemID, wHilite);
     // Force bits to be set call server side....
     // This alone works and passes all the menu test_menu_hilitemenuitem tests.
     if (!NtUserHiliteMenuItem(hWnd, hMenu, wItemID, wHilite)) return FALSE;
     // Without the above call we fail 3 out of the wine failed todo tests, see CORE-7967
     // Now redraw menu.
-    if (MenuGetRosMenuInfo(&MenuInfo, hMenu))
+/*    if (MenuGetRosMenuInfo(&MenuInfo, hMenu))
     {
        if (MenuInfo.iItem == wItemID) return TRUE;
        MenuHideSubPopups( hWnd, &MenuInfo, FALSE, 0 );
        MenuSelectItem( hWnd, &MenuInfo, wItemID, TRUE, 0 );
-    }
+    }*/
     return TRUE; // Always returns TRUE!
 }
 
Index: win32ss/user/user32/windows/nonclient.c
===================================================================
--- win32ss/user/user32/windows/nonclient.c	(revision 68654)
+++ win32ss/user/user32/windows/nonclient.c	(working copy)
@@ -275,8 +275,13 @@
    DWORD Style, ExStyle;
    HWND Parent;
    RECT ClientRect, WindowRect, CurrentRect, TempRect;
+   PWND pWnd;
 
-   if (!IsWindowVisible(hWnd))
+   pWnd = ValidateHwnd(hWnd);
+
+   if (!IsWindowVisible(hWnd) ||
+       (pWnd->state & WNDS_NONCPAINT && !(pWnd->state & WNDS_FORCEMENUDRAW)) ||
+        EqualRect(&pWnd->rcWindow, &pWnd->rcClient) )
       return 0;
 
    Style = GetWindowLongPtrW(hWnd, GWL_STYLE);
